/*
 * Smart GWT (GWT for SmartClient)
 * Copyright 2008 and beyond, Isomorphic Software, Inc.
 *
 * Smart GWT is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation.  Smart GWT is also
 * available under typical commercial license terms - see
 * http://smartclient.com/license
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 */
/* sgwtgen */
 
package com.smartgwt.client.types;

/**
 * Priority levels for log messages.
 */

public enum LogPriority implements ValueEnum {

    /**
     * Fatal errors only
     */
    FATAL("fatal"),

    /**
     * Fatal and regular Errors
     */
    ERROR("error"),

    /**
     * Warnings and Errors
     */
    WARN("warn"),

    /**
     * Information logs, as well as Warnings and Errors
     */
    INFO("info"),

    /**
     * All logs
     */
    DEBUG("debug");

    private String value;

    LogPriority(String value) {
        this.value = value;
    }
    
    public String getValue() {
        return this.value;
    }
}
